*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2006      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA200x:                                *
*                                                                      *
*     Created on 07 january 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 03-mar-06     by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*----------------------------------------------------------------------*
*  Version for isotropic Heavy ion source
*
      DIMENSION  CUMENE(28), ENELOW(28), ENEUP(28)  
*----------------------------------------------------------------------*
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*
      LOGICAL LFIRST

      parameter (pig=3.141592654)

      SAVE LFIRST
      DATA LFIRST / .TRUE. /
*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
*    Trapped proton (differential proton spectra by Spenvis)
      DATA ENELOW /
     & 1.00000D-04, 1.50000D-04, 2.00000D-04, 3.00000D-04, 4.00000D-04,
     & 5.00000D-04, 6.00000D-04, 7.00000D-04, 1.00000D-03, 1.50000D-03,
     & 2.00000D-03, 3.00000D-03, 4.00000D-03, 5.00000D-03, 6.00000D-03,
     & 7.00000D-03, 1.00000D-02, 1.50000D-02, 2.00000D-02, 3.00000D-02,
     & 4.00000D-02, 5.00000D-02, 6.00000D-02, 7.00000D-02, 1.00000D-01,
     & 1.50000D-01, 2.00000D-01, 3.00000D-01 /

      DATA ENEUP /
     & 1.50000D-04, 2.00000D-04, 3.00000D-04, 4.00000D-04, 5.00000D-04,
     & 6.00000D-04, 7.00000D-04, 1.00000D-03, 1.50000D-03, 2.00000D-03,
     & 3.00000D-03, 4.00000D-03, 5.00000D-03, 6.00000D-03, 7.00000D-03,
     & 1.00000D-02, 1.50000D-02, 2.00000D-02, 3.00000D-02, 4.00000D-02,
     & 5.00000D-02, 6.00000D-02, 7.00000D-02, 1.00000D-01, 1.50000D-01,
     & 2.00000D-01, 3.00000D-01, 4.00000D-01 /

*    Normalized spectrum
      DATA CUMENE / 
     & 1.90022D-01, 3.38551D-01, 5.60444D-01, 6.85931D-01, 7.62331D-01,
     & 8.09530D-01, 8.39417D-01, 8.97009D-01, 9.39441D-01, 9.51795D-01,
     & 9.63376D-01, 9.66675D-01, 9.68349D-01, 9.69383D-01, 9.70202D-01,
     & 9.72218D-01, 9.74436D-01, 9.75558D-01, 9.77225D-01, 9.78546D-01,
     & 9.79653D-01, 9.80796D-01, 9.81987D-01, 9.85386D-01, 9.90641D-01,
     & 9.94414D-01, 9.98535D-01, 1.00000D+00 /

*  +-------------------------------------------------------------------*   
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***
         write(lunout,*)
         write(lunout,*) ' modified source.f for trapped proton flux '
      END IF
*  |
*  +-------------------------------------------------------------------*
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated
* Npflka is the stack counter: of course any time source is called it
* must be =0
*      NPFLKA = NPFLKA + 1
* Wt is the weight of the particle
*      WTFLK  (NPFLKA) = ONEONE
*     WEIPRI = WEIPRI + WTFLK (NPFLKA)
* Particle type (1=proton.....). Ijbeam is the type set by the BEAM
* card
*  +-------------------------------------------------------------------*
* Sample the energy group
      XI = FLRNDM(DUMMY)
      YI = FLRNDM(DUMMY1)
      DO 500 K = 1 ,28
         IF (XI .LE. CUMENE(K)) THEN
            ENERGY = YI * (ENEUP(K) - ENELOW(K)) + ENELOW(K)
            write(82,*) k,enelow(k),eneup(k),cumene(k),energy
            GO TO 600
         END IF
 500   CONTINUE
       STOP ' Failed to sample the energy group '
 600   CONTINUE
       count=count+1
      NPFLKA = NPFLKA + 1
      WTFLK (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)
*  +--------------------------------------------------------------------*
*  |  (Radioactive) isotope:
      IF ( IJBEAM .EQ. -2 .AND. LRDBEA ) THEN
         IARES  = IPROA
         IZRES  = IPROZ
         IISRES = IPROM
         CALL STISBM ( IARES, IZRES, IISRES )
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
*  |
*  +-------------------------------------------------------------------*
*  |  Heavy ion:
      ELSE IF ( IJBEAM .EQ. -2 ) THEN
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
         ILOFLK (NPFLKA) = IJHION
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |
*  +-------------------------------------------------------------------*
*  |  Normal hadron:
      ELSE
         IONID = IJBEAM
         ILOFLK (NPFLKA) = IJBEAM
*  |  Flag this is prompt radiation
*         LRADDC (NPFLKA) = .FALSE.
      END IF
*  |
*  +-------------------------------------------------------------------*
* From this point .....
* Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
* User dependent flag:
      LOUSE  (NPFLKA) = 0
* User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
* User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
* Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
* ... to this point: don't change anything
* Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
* Group number for "low" energy neutrons, set to 0 anyway
      IGROUP (NPFLKA) = 0
* Kinetic energy of the particle (GeV)
      TKEFLK (NPFLKA) = ENERGY
*      TKEFLK (NPFLKA) = SQRT ( PBEAM**2 + AM (IONID)**2 ) - AM (IONID)
* Particle momentum
*      PMOFLK (NPFLKA) = PBEAM
      PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &                      + TWOTWO * AM (ILOFLK(NPFLKA)) ) )

      rsph = whasou(1)

* Isotropic and uniform distribution
      CALL SFLOOD ( XXX,YYY,ZZZ,UXXX, VYYY,WZZZ )
      UBEAM = UXXX
      VBEAM = VYYY
      WBEAM = WZZZ

* Cosines (tx,ty,tz)
      TXFLK  (NPFLKA) = UBEAM
      TYFLK  (NPFLKA) = VBEAM
      TZFLK  (NPFLKA) = WBEAM

      vc=sqrt(txflk(npflka)**2+tyflk(npflka)**2+tzflk(npflka)**2)
      write(81,*) txflk(npflka),tyflk(npflka),tzflk(npflka),vc

* Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER

* Particle coordinates
      XBEAM = XXX * rsph
      YBEAM = YYY * rsph
      ZBEAM = ZZZ * rsph

* Particle coordinates
      XFLK (NPFLKA) = XBEAM
      YFLK (NPFLKA) = YBEAM
      ZFLK (NPFLKA) = ZBEAM

      r_chk=sqrt(xflk(npflka)**2 + yflk(npflka)**2 + zflk(npflka)**2)
      write(82,*) xflk(npflka),yflk(npflka),zflk(npflka),rsph,r_chk

*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER
*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )
*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*=== End of subroutine Source =========================================*
      END


